# Slower than list by a factor of 1.25
# proc expandHex2 {str} {
#     set n ""
#     for {set s 0; set e 1} {$e < [string length $str]} {incr s 2; incr e 2} {
#         append n "[string range $str $s $e] "
#     }
#     return $n
# }

namespace eval binaryStrings {

# Slower than regsub by factor of 1.1
#
#  proc bin2hex {binaryString} {
#      binary scan $binaryString "H*" hexData
#      return [expandHex $hexData]
#  }
#  proc expandHex {str} {
#     set n ""
#     foreach  {h l } [split $str ""] {
#       append n "${h}${l} "
#     }
#  return $n
#  }

  proc bin2hex {binaryString} {
      binary scan $binaryString "H*" hexData
      regsub -all {([^ ]) ([^ ])} [split $hexData ""] {\1\2} hexList
      return $hexList
  }

# Slower than single format command by a factor of 5
#  proc hex2bin {string} {
#    regsub -all " " $string "" string
#    set line ""
#    set string [expandHex $string]
#    foreach v $string {
#         set letter [binary format H2 $v]
#         append line $letter
#    }
#    return $line
#  }

  proc hex2bin {string} {
    regsub -all " " $string "" string
    set line [binary format "H*" $string]
    return $line
  }
}
